From 5c9eb6b6ba64c4eb927d7a902317410181aacbba Mon Sep 17 00:00:00 2001
From: Hoa Dinh <hoa@dinhvh.me>
Date: Mon, 19 Dec 2022 08:16:32 -0800
Subject: [PATCH] Fixed crash when st_info_list is NULL. Fixes #420. Fixes
 CVE-2022-4121.

---
 src/low-level/imap/mailimap_types.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

diff --git a/src/low-level/imap/mailimap_types.c b/src/low-level/imap/mailimap_types.c
index 9923125c..79a0cc23 100644
--- a/src/low-level/imap/mailimap_types.c
+++ b/src/low-level/imap/mailimap_types.c
@@ -1389,9 +1389,11 @@ void
 mailimap_mailbox_data_status_free(struct mailimap_mailbox_data_status * info)
 {
   mailimap_mailbox_free(info->st_mailbox);
-  clist_foreach(info->st_info_list, (clist_func) mailimap_status_info_free,
-		 NULL);
-  clist_free(info->st_info_list);
+  if (info->st_info_list != NULL) {
+    clist_foreach(info->st_info_list, (clist_func) mailimap_status_info_free,
+      NULL);
+    clist_free(info->st_info_list);
+  }
   free(info);
 }
 
